"""J.A.R.V.I.S. unlock background task handler."""
from asyncio import to_thread
from datetime import datetime, timedelta

from dis_snek.ext.tasks.task import Task
from dis_snek.ext.tasks.triggers import IntervalTrigger

import jarvis
from jarvis.db.models import Lock


async def _unlock() -> None:
    """J.A.R.V.I.S. unlock blocking task."""
    locks = Lock.objects(active=True)
    # Block execution for now
    # TODO: Reevaluate with admin/lock[down]
    if False:
        for lock in locks:
            if lock.created_at + timedelta(minutes=lock.duration) < datetime.utcnow():
                guild = await jarvis.jarvis.get_guild(lock.guild)
                channel = await jarvis.jarvis.get_guild(lock.channel)
                if channel:
                    roles = await guild.fetch_roles()
                    for role in roles:
                        overrides = channel.overwrites_for(role)
                        overrides.send_messages = None
                        await channel.set_permissions(
                            role, overwrite=overrides, reason="Lock expired"
                        )
                lock.active = False
                lock.save()


@Task.create(IntervalTrigger(minutes=1))
async def unlock() -> None:
    """J.A.R.V.I.S. unlock background task."""
    await to_thread(_unlock)
